#ifndef _TRAYHANDLER_CPP
#define _TRAYHANDLER_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../Resources/Resource.H"

#include "Entry.H"
#include "Init.H"
#include "TrayIcon.H"
#include "TrayHandler.H"
#include "Registry.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool bFirstCall = true;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

LRESULT CALLBACK TrayIconProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	if(uMsg == WM_CREATE)
    {
		SetTimer(hWnd, 0, 1000, NULL);

		TB_CREATED = RegisterWindowMessage("TaskbarCreated");
        return DefWindowProc(hWnd, uMsg, wParam, lParam);
    }

	if(uMsg == WM_COMMAND)
    {
        if(LOWORD(wParam) == ID_EXIT)
        {
            DestroyWindow(hWnd);
        }
		else if(LOWORD(wParam) == ID_STARTSERVER)
        {
			StartService();
        }
		else if(LOWORD(wParam) == ID_STOPSERVER)
        {
			StopService();
        }
		else if(LOWORD(wParam) == ID_CANCEL)
        {
        }

        return DefWindowProc(hWnd, uMsg, wParam, lParam);
    }

	if(uMsg == WM_TIMER)
    {
		if(Get_BOOLRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "TerminateAgent"))
		{
			DestroyWindow(hWnd);
		}
	}
	
    if(uMsg == WM_SHELLNOTIFY)
    {
        if(lParam == WM_RBUTTONDOWN)
        {
			POINT MyPT;

			GetCursorPos(&MyPT);
            SetForegroundWindow(hWnd);
            TrackPopupMenuEx(hFileMenu, TPM_LEFTALIGN| TPM_RIGHTBUTTON, MyPT.x, MyPT.y, hWnd, NULL);
            PostMessage(hWnd, WM_NULL, 0, 0);
        }

        return DefWindowProc(hWnd, uMsg, wParam, lParam);
    }

    if(uMsg == WM_DESTROY)
    {
		KillTimer(hWnd, 0);
        UnregisterClass(gsTitleCaption, ghAppInstance);
        Shell_NotifyIconA(NIM_DELETE, &MyTrayNotifiy);
        PostQuitMessage(0);
        return DefWindowProc(hWnd, uMsg, wParam, lParam);
    }

    if(uMsg == WM_CLOSE)
    {
        DestroyWindow(hWnd);
        return DefWindowProc(hWnd, uMsg, wParam, lParam);
    }

    if(uMsg == TB_CREATED)
    {
        Shell_NotifyIcon(NIM_ADD, &MyTrayNotifiy);
    }

    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
